﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Net.Mail;
using System.Data;
using System.Threading.Tasks;

public partial class CS : System.Web.UI.Page
{
protected void Page_Load(object sender, EventArgs e)
{
    if (!this.IsPostBack)
    {
        DataTable dt = new DataTable();
        dt.Columns.AddRange(new DataColumn[3] { new DataColumn("Id", typeof(int)),
                        new DataColumn("Name", typeof(string)),
                        new DataColumn("Email",typeof(string)) });
        dt.Rows.Add(1, "John Hammond", "john.hammond@test.com");
        dt.Rows.Add(2, "Mudassar Khan", "mudassar.khan@test.com");
        dt.Rows.Add(3, "Suzanne Mathews", "suzzane.mathews@test.com");
        dt.Rows.Add(4, "Robert Schidner", "robert.schidner@test.com");
        GridView1.DataSource = dt;
        GridView1.DataBind();
    }
}

protected void SendBulkEmail(object sender, EventArgs e)
{
    //Create a temporary DataTable
    DataTable dtCustomers = new DataTable();
    dtCustomers.Columns.AddRange(new DataColumn[2] { new DataColumn("Name", typeof(string)),
                        new DataColumn("Email",typeof(string)) });

    //Copy the Checked Rows to DataTable
    foreach (GridViewRow row in GridView1.Rows)
    {
        if ((row.FindControl("chkSelect") as CheckBox).Checked)
        {
            dtCustomers.Rows.Add(row.Cells[2].Text, (row.FindControl("lnkEmail") as HyperLink).Text);
        }
    }

    string subject = "Welcome Email";
    string body = "Hello {0},<br /><br />Welcome to ASPSnippets<br /><br />Thanks.";

    //Using Parallel Multi-Threading send multiple bulk email.
    Parallel.ForEach(dtCustomers.AsEnumerable(), row =>
    {
        SendEmail(row["Email"].ToString(), subject, string.Format(body, row["Name"]));
    });      
}

private bool SendEmail(string recipient, string subject, string body)
{
    MailMessage mm = new MailMessage("sender@gmail.com", recipient);
    mm.Subject = subject;
    mm.Body = body;
    mm.IsBodyHtml = true;
    SmtpClient smtp = new SmtpClient();
    smtp.Host = "smtp.gmail.com";
    smtp.EnableSsl = true;
    NetworkCredential NetworkCred = new NetworkCredential();
    NetworkCred.UserName = "sender@gmail.com";
    NetworkCred.Password = "<password>";
    smtp.UseDefaultCredentials = true;
    smtp.Credentials = NetworkCred;
    smtp.Port = 587;
    smtp.Send(mm);
    return true;
}
}